package com.huojutech.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * 用于参数XSS防御，
 * 还有种方法是全部string类型参数做参数过滤 效率可能稍微低点，但是相对简单
 * @author Administrator
 *
 */
@Documented
@Target({ElementType.PARAMETER, ElementType.FIELD, ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
public @interface XssParameter {
	
	String getValue() default "xss";
}
