package com.huojutech.config;


import com.google.common.collect.Sets;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

/***
  * 日志配置文件
  * Create_By  Wangzw
  * 2018\4\11 0011
 */
@Configuration
@EnableSwagger2
public class Swagger2Configuration {

	@Value("${swagger.show}")
	private boolean swaggerShow;

	@Bean
	public Docket configSpringfoxDocketForAgent() {
		return new Docket(DocumentationType.SWAGGER_2)
				.groupName("火钻接口文档").enable(swaggerShow)
				.protocols(Sets.newHashSet("http"))
				.forCodeGeneration(true).select()
				.paths(PathSelectors.any())
//				.paths(regex("/account/.*"))//只显示请求路径是account下的注释
				.apis(RequestHandlerSelectors.basePackage("com.huojutech.controller"))
				.build().apiInfo(apiInfo());
	}

	private ApiInfo apiInfo() {
		return new ApiInfoBuilder()
				.title("火钻接口服务")// 标题
				.description("系统API接口文档")// 描述
				.termsOfServiceUrl("http://www.huojutech.com")//
				.contact(new Contact("Wangzw", "http://www.huojutech.com", "997663551@qq.com"))// 联系，创建人
				.version("1.0")// 版本
				.build();
	}
}
