package com.huojutech.constant;

import com.huojutech.entity.User;
import com.huojutech.request.RequestSessionKey;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.core.ValueOperations;
import org.springframework.stereotype.Component;

import java.util.concurrent.TimeUnit;

@Component
public class SessionConstants implements InitializingBean{
	public static final String SESSION_KEY_COOKIE_NAME = "HUOZUAN_T";
	public static final int DEFAULT_SESSION_COOKIE_EXPIRE = 172800;
	public static final String SESSION_KEY_PREFIX = "USER";

	@Autowired
	private RedisTemplate<Object, Object> redisTemplate;
	
	private static RedisTemplate<Object, Object> baseRedisTemplate;
	
	

	public static void setSession(User user){
		ValueOperations<Object, Object> ops = baseRedisTemplate.opsForValue();
		ops.set(SESSION_KEY_PREFIX+":"+RequestSessionKey.getSessionKey(),user.getId(),DEFAULT_SESSION_COOKIE_EXPIRE,TimeUnit.SECONDS);
	}

	public static Integer getSession(){
		ValueOperations<Object, Object> ops  = baseRedisTemplate.opsForValue();
		Integer sessionValue = (Integer) ops.get(SESSION_KEY_PREFIX+":"+RequestSessionKey.getSessionKey());

		return sessionValue;
	}

    @Override
    public void afterPropertiesSet() throws Exception {
        baseRedisTemplate = this.redisTemplate;
    }

}
