package com.huojutech.constant.wx;

/**
 * 微信信息
 * Created by Wangzw on 2018\4\16 0016.
 */

public class UserInfo {

    /**
     * appid 小程序id
     * 微信公众平台 设置中的开发设置中可以查到，相当于qq的qq号
     * 建议单独创建一个配置文件储存此类值和函数
     */
    public static final String APPID="wx427434d3db046ee8";
    /**
     * AppSecret 小程序密钥
     * 微信公众平台 设置中的开发设置中可以查询 但是每次查询会重置密钥 相当于qq的qq密码
     * 建议单独储存
     */
    public static final String SECRET="f3df0c857279936dff4b86c429470582";
    /**
     *用于获取用户openid的接口网址
     * 其中%s将会用String.format函数替换为实际的值
     */
    public static final String Web_access_tokenhttps = "https://api.weixin.qq.com/sns/jscode2session?appid=%s&secret=%s&js_code=%s&grant_type=authorization_code";
    /**
     *通过APPID，SECET，code组合出用于获取用户openid的实际网址
     * 建议单独储存
     */
    public static String getWebAccess(String code) {
        return String.format(Web_access_tokenhttps, APPID, SECRET, code);
    }

    /**
     *用于获取用户accessToken的接口网址
     * 其中%s将会用String.format函数替换为实际的值
     */
    public static final String access_token="https://api.weixin.qq.com/cgi-bin/token?appid=%s&secret=%s&grant_type=client_credential";

    /**
     *通过APPID，SECET，code组合出用于获取用户openid的实际网址
     * 建议单独储存
     */
    public static String getAccess_token() {
        return String.format(access_token, APPID, SECRET);
    }

    /**
     * unionID
     */
    public static final String unionId= "https://api.weixin.qq.com/cgi-bin/user/info?access_token=%s&openid=%s&lang=zh_CN";

    public static String getUnionId(String access_token,String openId){
        return String.format(unionId,access_token ,openId);
    }

}

