package com.huojutech.controller.weixin;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.huojutech.constant.SessionConstants;
import com.huojutech.entity.DiamondRecord;
import com.huojutech.service.DiamondRecordService;
import com.huojutech.utils.ResultEnum;
import com.huojutech.vo.PageResultVO;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;

/**
 * Created by Wangzw on 2018\4\19 0019.
 */
@RestController
@Api(description = "火钻记录接口")
@RequestMapping("/wx/diamondRecord")
public class DiamondRecordController {

    @Autowired
    private DiamondRecordService diamondRecordService;

    @RequestMapping(value = "/list",produces = "application/json;charset=utf-8",method = RequestMethod.GET)
    @ApiOperation(value="查询火钻记录",notes="根据uid查询火钻记录",response = DiamondRecord.class)
    public PageResultVO<List<DiamondRecord>> findDiamondRecord(
                                        @ApiParam(value="分页大小,默认10",required=false) @RequestParam(required=false,defaultValue="10") Integer size,
                                        @ApiParam(value="页码 ，第一页为1") @RequestParam(required=false,defaultValue="1") Integer page){
        Integer uid = SessionConstants.getSession();
        List<DiamondRecord> recordList = diamondRecordService.findDiamondRecord(uid,page,size);

        PageResultVO<List<DiamondRecord>> vo = new PageResultVO<>();
        vo.setData(recordList);

        vo.setCode(ResultEnum.SUCCESS.getCode());
        vo.setMsg(ResultEnum.SUCCESS.getMessage());
        return vo;

    }
}
