package com.huojutech.dao;

import com.huojutech.dto.SeerListDTO;
import com.huojutech.entity.StockForecast;
import com.huojutech.entity.StockForecastExample;
import com.huojutech.entity.User;
import com.huojutech.entity.UserConcern;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;
@Mapper
public interface StockForecastMapper {
    int countByExample(StockForecastExample example);

    int deleteByPrimaryKey(Integer id);

    int insert(StockForecast record);

    int insertSelective(StockForecast record);

    List<StockForecast> selectByExampleWithBLOBs(StockForecastExample example);

    List<StockForecast> selectByExample(StockForecastExample example);

    StockForecast selectByPrimaryKey(Integer id);

    int updateByPrimaryKeySelective(StockForecast record);

    int updateByPrimaryKeyWithBLOBs(StockForecast record);

    int updateByPrimaryKey(StockForecast record);

    Integer selectForecastCounts(@Param("uid") Integer uid);


    List<StockForecast> findMyForecastOff(@Param("uid") Integer uid,@Param("listStatus") List<Integer> listStatus);

    Integer findVoteNum(@Param("uid") Integer uid, @Param("stockName") String stockName);


    List<StockForecast> findMyVoteOn(@Param("uid") Integer uid, @Param("status") Integer status);

    List<StockForecast> findMyVoteOff(@Param("uid") Integer uid,@Param("listStatus") List<Integer> listStatus);

    /**
     * 查询所有预测者
     * @param isSubscribe
     * @param allForecast
     * @param nickName
     * @param fnumOrderby
     * @param frateOrderby
     * @param concernOrderby
     * @return
     */
    List<SeerListDTO> selectAllForecasts(@Param("allForecast") List<StockForecast> allForecast, @Param("nickName") String nickName, @Param("fnumOrderby") Integer fnumOrderby, @Param("frateOrderby") Integer frateOrderby, @Param("concernOrderby") Integer concernOrderby, @Param("stockCode") String stockCode);

    /**
     * 查询所有预测者的uid
     * @return
     */
    List<StockForecast> findAllForecastUID();
    
    /**
     * 加减预测投票数
     * @param id
     * @param vnum
     * @return
     */
    int updateNumberById(@Param("id") Integer id, @Param("vnum") Integer vnum);

    /**
     * 查询所有我关注的预言家
     * @param concerns
     * @param nickName
     * @param fnumOrderby
     * @param frateOrderby
     * @param concernOrderby
     * @param stockCode
     * @return
     */
    List<SeerListDTO> selectAllConcern(@Param("concerns") List<UserConcern> concerns, @Param("nickName") String nickName, @Param("fnumOrderby") Integer fnumOrderby, @Param("frateOrderby") Integer frateOrderby, @Param("concernOrderby") Integer concernOrderby, @Param("stockCode") String stockCode);

    /**
     * 通过预测id更新投票收益
     * @param forecastId
     * @param harvest
     * @return
     */
    Integer updateVoteHarvestById(@Param("forecastId") Integer forecastId,@Param("harvest") BigDecimal harvest);

    /**
     * 更多推荐的预言家列表
     * @param recommondUid
     * @param nickName
     * @param fnumOrderby
     * @param frateOrderby
     * @param concernOrderby
     * @param stockCode
     * @return
     */
    List<SeerListDTO> findAllRecommend(@Param("recommondUid") List<User> recommondUid, @Param("nickName") String nickName, @Param("fnumOrderby") Integer fnumOrderby, @Param("frateOrderby") Integer frateOrderby, @Param("concernOrderby") Integer concernOrderby, @Param("stockCode") String stockCode);

}