
package com.huojutech.dao;

import com.huojutech.entity.User;
import com.huojutech.entity.UserExample;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
@Mapper
public interface UserMapper {
    int countByExample(UserExample example);

    int deleteByPrimaryKey(Integer id);

    int insert(User record);

    int insertSelective(User record);

    List<User> selectByExample(UserExample example);

    User selectByPrimaryKey(Integer id);

    int updateByPrimaryKeySelective(User record);

    int updateByPrimaryKey(User record);

    User findUserByOpenId(@Param("openId") String openId);

    /**
     * 修改用户火钻数
     * @param uid           用户id
     * @param amount        修改火钻数   正数为加，负数为减
     * @return
     */
    int updateAmountByUid(@Param("uid") Integer uid, @Param("amount") Double amount);
    
    /**
     * 加减指定用户预测数/投票数/被关注数
     * @param uid           用户id
     * @param fnum          预测数
     * @param vnum          投票数
     * @param cnum          被关注数
     * @param voteNum
     * @return
     */
    int updateNumberById(@Param("uid") Integer uid, @Param("fnum") Integer fnum, @Param("vnum") Integer vnum, @Param("cnum") Integer cnum,@Param("voteNum") Integer voteNum);

    /**
     * 更新用户的被关注数和关注数
     * @param cnum 被关注数
     * @param concernNum 关注数
     */
    void updateCnumByUID(@Param("id") Integer id,@Param("cnum") Integer cnum,@Param("concernNum") Integer concernNum);


    /**
     * 查询推荐的预言家
     * @return
     */
    List<User> selectRecommendUser();

    /**
     * 查看推荐的预言家id
     * @return
     */
    List<User> selectRecommondUid();
}