
package com.huojutech.exception;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

import com.huojutech.utils.UrlUtils;

/**
 * Created by Wangzw on 2018\4\10 0010.
 */
@ControllerAdvice
public class GlobalExceptionHandler {

    private static Logger logger = LoggerFactory.getLogger(GlobalExceptionHandler.class);

    @ExceptionHandler(value = Exception.class)
    @ResponseBody
    public String defaultErrorHandler(HttpServletRequest req, Exception e) throws Exception {
        logger.error(UrlUtils.getRequestParams(req));
        logger.error(UrlUtils.getRequestPayload(req));
        logger.error(e.getMessage() + " " + req.getRequestURL(), e);
        return "error happens";
    }

}
