package com.huojutech.interceptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import com.huojutech.annotation.SkipLogin;

public class AdminInterceptor implements HandlerInterceptor {

	private static final Logger logger = Logger.getLogger(AdminInterceptor.class);
	
	@Override
	public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {
	}

	@Override
	public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {

	}

	@Override
	public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {

		HandlerMethod handlerMethod = (HandlerMethod) handler;
		SkipLogin skipLogin = handlerMethod.getMethodAnnotation(SkipLogin.class);

		if (skipLogin != null) {// 不需要登录，直接访问
			return true;
		}

		String requestURI = request.getPathInfo();
		Long loginSupplierBossId = null;//CurrentUserUtil.getLoginSupplierBossId(RequestSessionKey.getSessionKey());
		// 管理后台判断是否登录

		if (loginSupplierBossId == null) {
			response.setContentType("application/json");
			response.getWriter().write("{\"status\":\"401\"}");
			response.getWriter().flush();
			return false;
		}
		logger.info(loginSupplierBossId + " 访问 " + requestURI);

		return true;
	}
}
