package com.huojutech.interceptor;

import java.lang.reflect.Method;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import com.huojutech.annotation.CsrfTokenAction;

public class CsrfTokenInterceptor extends HandlerInterceptorAdapter {

//	@Resource
//	private BaseRedisClient sessionRedisClient;
	
	@Override
	public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
		if (handler instanceof HandlerMethod) {
			HandlerMethod handlerMethod = (HandlerMethod) handler;
			Method method = handlerMethod.getMethod();
			if (method.isAnnotationPresent(CsrfTokenAction.class)) {
				String requestTokenValue = request.getParameter("csrf");
//				String key = sessionRedisClient.hget(RequestSessionKey.getSessionKey(), RedisKeyConstants.CSRFKey());
//				if (StringUtils.isNotBlank(requestTokenValue) && requestTokenValue.equals(key)) {
//					return true;
//				}
				response.setContentType("application/json");
				response.getWriter().write("{\"status\":\"401\"}");
				response.getWriter().flush();
				return false;
			}
		}
		return true;
	}
}
