package com.huojutech.interceptor;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.springframework.stereotype.Service;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.method.annotation.ExceptionHandlerExceptionResolver;

import com.huojutech.request.RequestSessionKey;
import com.huojutech.utils.UrlUtils;

@Service
public class MyExceptionResolver extends ExceptionHandlerExceptionResolver {

	private static final Logger logger = Logger.getLogger(MyExceptionResolver.class);

	@Override
	public ModelAndView resolveException(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) {
		if (handler == null) {
			return null;
		}
		try {
			logger.error(ex.getMessage(), ex);
			StringBuilder log = new StringBuilder();
			log.append("sid:" + RequestSessionKey.getSessionKey());
			log.append(request.getPathInfo()).append("?");
			log.append(UrlUtils.getRequestParams(request));
			log.append(UrlUtils.getRequestPayload(request));
			logger.error(log, ex);
		} catch (Exception e) {
			logger.error(e);
		}
		String requestURI = request.getPathInfo();

		if (requestURI.endsWith(".json")) {
			try {
				PrintWriter writer = response.getWriter();
				writer.write("{\"status\":\"5000\"}");
				writer.flush();
			} catch (IOException e) {
				logger.error(e);
			}
		}
		return new ModelAndView();
	}
}