package com.huojutech.interceptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import com.huojutech.annotation.SkipLogin;
import com.huojutech.constant.SessionConstants;
import com.huojutech.utils.ResultEnum;

public class SmallAppInterceptor implements HandlerInterceptor {

	private static final Logger logger = Logger.getLogger(SmallAppInterceptor.class);
	
	@Override
	public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {
	}

	@Override
	public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {

	}

	@Override
	public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {

		HandlerMethod handlerMethod = (HandlerMethod) handler;
		SkipLogin skipLogin = handlerMethod.getMethodAnnotation(SkipLogin.class);

		if (skipLogin != null) {// 不需要登录，直接访问
			return true;
		}

		String requestURI = request.getPathInfo();
		Integer uid = SessionConstants.getSession();
		// 管理后台判断是否登录

		if (uid == null) {
			response.setContentType("application/json;charset=utf-8");
			response.getWriter().write("{\"code\":\""+ResultEnum.NO_LOGIN.getCode()+"\",\"msg\":\""+ResultEnum.NO_LOGIN.getMessage()+"\"}");
			response.getWriter().flush();
			return false;
		}
		logger.info(uid + " 访问 " + requestURI);

		return true;
	}
}
