package com.huojutech.request;

import java.io.IOException;
import java.lang.reflect.Method;
import java.lang.reflect.Type;

import org.springframework.http.HttpInputMessage;
import org.springframework.http.converter.HttpMessageNotReadableException;
import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter;
import org.springframework.util.ReflectionUtils;

import com.huojutech.annotation.XssParameter;

public class XssMessageConverter extends MappingJackson2HttpMessageConverter {

	@Override
	public Object read(Type type, Class<?> contextClass, HttpInputMessage inputMessage)
			throws IOException, HttpMessageNotReadableException {

		Object object = super.read(type, contextClass, inputMessage);
		Class<?> clazz = object.getClass();
		
		if (clazz.isAnnotationPresent(XssParameter.class)) {
			Method[] methods = ReflectionUtils.getAllDeclaredMethods(clazz);
			
			for (Method method : methods) {
				XssUtil.htmlEscape(method, object);
			}
		}
		
		return object;
	}

}
