package com.huojutech.request;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

import org.apache.commons.lang3.StringUtils;
import org.springframework.util.ReflectionUtils;
import org.springframework.web.util.HtmlUtils;

public class XssUtil {

	/**
	 * 对对象里面的某个字段htmlEscape处理
	 * @param method
	 * @param object
	 */
	public static void htmlEscape(Method method, Object object) {
		Class<?> clazz = object.getClass();
		String methodName = method.getName();
		if (methodName.startsWith("get") && !methodName.equals("getClass")) {
			String fieldName = methodName.substring(3, 4).toLowerCase() + (methodName.length() > 4 ? methodName.substring(4, methodName.length()) : "");
			Field field = ReflectionUtils.findField(clazz, fieldName);
			
			if (field != null && field.getType().getName().equals("java.lang.String")) {
				String oldValue = (String) ReflectionUtils.invokeMethod(method, object);
				if (StringUtils.isNotBlank(oldValue)) {
					String value = HtmlUtils.htmlEscape(oldValue);
					ReflectionUtils.makeAccessible(field);
					ReflectionUtils.setField(field, object, value);
				}
			}
		}
	}
}
