package com.huojutech.service;

import com.huojutech.dto.SeerListDTO;
import com.huojutech.entity.StockForecast;
import com.huojutech.entity.User;
import com.huojutech.entity.UserConcern;

import java.util.List;

/**
 * Created by Wangzw on 2018\4\19 0019.
 */

public interface ForecastService {

    /**
     * 查询所有预言者的uid
     * @return
     */
    List<StockForecast> findAllForecastUID();

    /**
     * 根据用户id，查询预测的数量
     * @param id
     * @return
     */
    Integer findForecastNumByUid(Integer id);

    /**
     * 查询所有的预测者
     * @param allForecast
     * @param nickName
     * @param fnumOrderby
     * @param frateOrderby
     * @param concernOrderby
     * @param stockCode
     * @return
     */
    List<SeerListDTO> findAllForecast(List<StockForecast> allForecast, String nickName, Integer fnumOrderby, Integer frateOrderby, Integer concernOrderby, String stockCode);

    /**
     * 查找预言家预测的股票列表
     * @param id
     * @return
     */
    List<StockForecast> findSeerForecast(Integer id);

    /**
     * 通过预测id查找预测
     * @param forecastId
     * @return
     */
    StockForecast findForecastById(Integer forecastId);

    /**
     * 查找正在预测中的股票
     * @param uid
     * @param status
     * @return
     */
    List<StockForecast> findForecastOn(Integer uid, Integer status);

    /**
     * 查找正在预测结束的股票
     * @param uid
     * @param numList
     * @return
     */
    List<StockForecast> findForecastOff(Integer uid, List<Integer> numList);

    /**
     * 查询所有我订阅的预言家
     * @param concerns
     * @param nickName
     * @param fnumOrderby
     * @param frateOrderby
     * @param concernOrderby
     * @param stockCode
     * @return
     */
    List<SeerListDTO> findAllConcern(List<UserConcern> concerns, String nickName, Integer fnumOrderby, Integer frateOrderby, Integer concernOrderby, String stockCode);

    /**
     * 更多推荐的预言家列表
     * @param recommondUid
     * @param nickName
     * @param fnumOrderby
     * @param frateOrderby
     * @param concernOrderby
     * @param stockCode
     * @return
     */
    List<SeerListDTO> findAllRecommend(List<User> recommondUid, String nickName, Integer fnumOrderby, Integer frateOrderby, Integer concernOrderby, String stockCode);
}

