
package com.huojutech.service.Impl;

import com.huojutech.dao.StockForecastMapper;
import com.huojutech.dto.SeerListDTO;
import com.huojutech.entity.StockForecast;
import com.huojutech.entity.StockForecastExample;
import com.huojutech.entity.StockForecastExample.Criteria;
import com.huojutech.entity.User;
import com.huojutech.entity.UserConcern;
import com.huojutech.service.ForecastService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by Wangzw on 2018\4\19 09.
 */
@Service
public class ForecastServiceImpl implements ForecastService {

    @Autowired
    private StockForecastMapper stockForecastMapper;

    @Override
    public List<StockForecast> findAllForecastUID() {
        return stockForecastMapper.findAllForecastUID();
    }


    @Override
    public Integer findForecastNumByUid(Integer id) {
        return stockForecastMapper.selectForecastCounts(id);
    }


    @Override
    public List<SeerListDTO> findAllForecast(List<StockForecast> allForecast, String nickName, Integer fnumOrderby, Integer frateOrderby, Integer concernOrderby, String stockCode) {
        return stockForecastMapper.selectAllForecasts(allForecast,nickName,fnumOrderby,frateOrderby,concernOrderby,stockCode);
    }

    @Override
    public List<StockForecast> findSeerForecast(Integer id) {
        StockForecastExample example = new StockForecastExample();
        example.setOrderByClause("crt_time desc,id desc");
        Criteria criteria = example.createCriteria();
        criteria.andUidEqualTo(id);
        List<StockForecast> stockForecasts = stockForecastMapper.selectByExample(example);
        return stockForecasts;
    }

    @Override
    public StockForecast findForecastById(Integer forecastId) {
        return stockForecastMapper.selectByPrimaryKey(forecastId);
    }

    @Override
    public List<StockForecast> findForecastOn(Integer uid, Integer status) {
        StockForecastExample example = new StockForecastExample();
        example.setOrderByClause("crt_time desc,id desc");
        StockForecastExample.Criteria criteria = example.createCriteria();
        criteria.andUidEqualTo(uid);
        criteria.andStatusEqualTo(status);
        List<StockForecast> stockForecasts = stockForecastMapper.selectByExample(example);
        return stockForecasts;
    }

    @Override
    public List<StockForecast> findForecastOff(Integer uid, List<Integer> numList) {
        StockForecastExample example = new StockForecastExample();
        example.setOrderByClause("crt_time desc,id desc");
        StockForecastExample.Criteria criteria2 = example.createCriteria();
        criteria2.andUidEqualTo(uid);
        criteria2.andStatusIn(numList);
        List<StockForecast> stockForecasts = stockForecastMapper.selectByExample(example);
        return stockForecasts;
    }

    @Override
    public List<SeerListDTO> findAllConcern(List<UserConcern> concerns, String nickName, Integer fnumOrderby, Integer frateOrderby, Integer concernOrderby, String stockCode) {
        return stockForecastMapper.selectAllConcern(concerns,nickName,fnumOrderby,frateOrderby,concernOrderby,stockCode);
    }

    @Override
    public List<SeerListDTO> findAllRecommend(List<User> recommondUid, String nickName, Integer fnumOrderby, Integer frateOrderby, Integer concernOrderby, String stockCode) {
        return stockForecastMapper.findAllRecommend(recommondUid,nickName,fnumOrderby,frateOrderby,concernOrderby,stockCode);
    }
}

