package com.huojutech.service.Impl;

import com.huojutech.dao.StockForecastVoteMapper;
import com.huojutech.entity.StockForecastVote;
import com.huojutech.entity.StockForecastVoteExample;
import com.huojutech.entity.StockForecastVoteExample.Criteria;
import com.huojutech.service.StockForecastVoteService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class StockForecastVoteServiceImpl implements StockForecastVoteService{
    @Autowired
    private StockForecastVoteMapper stockForecastVoteMapper;
    
    /*
     * (non-Javadoc)
     * @see com.huojutech.service.StockForecastVoteService#selectByUidAndForecastId(java.lang.Integer, java.lang.Integer)
     */
    @Override
    public List<StockForecastVote> selectByUidAndForecastId(Integer uid, Integer forecastId) {
        StockForecastVoteExample example = new StockForecastVoteExample();
        Criteria c = example.createCriteria();
        c.andUidEqualTo(uid);
        c.andForecastIdEqualTo(forecastId);
        c.andStatusEqualTo(0);//未删除记录
        return stockForecastVoteMapper.selectByExample(example);
    }
    
    /*
     * (non-Javadoc)
     * @see com.huojutech.service.StockForecastVoteService#countByUidAndForecastId(java.lang.Integer, java.lang.Integer)
     */
    @Override
    public Integer countByUidAndForecastId(Integer uid, Integer forecastId) {
        StockForecastVoteExample example = new StockForecastVoteExample();
        Criteria c = example.createCriteria();
        c.andUidEqualTo(uid);
        c.andForecastIdEqualTo(forecastId);
        c.andStatusEqualTo(0);//未删除记录
        return stockForecastVoteMapper.countByExample(example);
    }

    /*
     * (non-Javadoc)
     * @see com.huojutech.service.StockForecastVoteService#insert(com.huojutech.entity.StockForecastVote)
     */
    @Override
    public int insert(StockForecastVote vote) {
        return stockForecastVoteMapper.insert(vote);
    }
    
    /*
     * (non-Javadoc)
     * @see com.huojutech.service.StockForecastVoteService#selectVoteCounts(java.lang.Integer)
     */
    @Override
    public Integer selectVoteCounts(Integer uid) {
        return stockForecastVoteMapper.selectVoteCounts(uid);
    }

    /*
     * (non-Javadoc)
     * @see com.huojutech.service.StockForecastVoteService#upsert(com.huojutech.entity.StockForecastVote)
     */
    @Override
    public int upsert(StockForecastVote record) {
        return stockForecastVoteMapper.upsert(record);
    }

    @Override
    public List<StockForecastVote> selectByUid(Integer sessionId, Integer id) {
        StockForecastVoteExample example = new StockForecastVoteExample();
        Criteria c = example.createCriteria();
        c.andUidEqualTo(sessionId);
        c.andForecastIdEqualTo(id);
        List<StockForecastVote> stockForecastVotes = stockForecastVoteMapper.selectByExample(example);
        return stockForecastVotes;
    }

    @Override
    public List<StockForecastVote> selectByForecastId(Integer id) {
        StockForecastVoteExample example = new StockForecastVoteExample();
        Criteria c = example.createCriteria();
        c.andForecastIdEqualTo(id);
        c.andStatusEqualTo(0);
        List<StockForecastVote> stockForecastVotes = stockForecastVoteMapper.selectByExample(example);
        return stockForecastVotes;
    }

    @Override
    public int updateVote(StockForecastVote stockForecastVote) {
        return stockForecastVoteMapper.updateByPrimaryKeySelective(stockForecastVote);
    }

    @Override
    public List<StockForecastVote> findVoteByUid(Integer sessionId) {
        StockForecastVoteExample example = new StockForecastVoteExample();
        Criteria c = example.createCriteria();
        c.andUidEqualTo(sessionId);
        return stockForecastVoteMapper.selectByExample(example);
    }
}