package com.huojutech.service.Impl;

import com.huojutech.dao.UserConcernMapper;
import com.huojutech.dao.UserMapper;
import com.huojutech.entity.UserConcern;
import com.huojutech.entity.UserConcernExample;
import com.huojutech.entity.UserConcernExample.Criteria;
import com.huojutech.service.UserConcernService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by Wangzw on 2018\4\20 0020.
 */
@Service
public class UserConcernServiceImpl implements UserConcernService{

    @Autowired
    private UserConcernMapper userConcernMapper;

    @Autowired
    private UserMapper userMapper;

    @Override
    public Integer selectConcernCounts(Integer uid) {
        return userConcernMapper.selectConcernCounts(uid);
    }

    @Override
    public Integer selectFansCounts(Integer uid) {
        return userConcernMapper.selectFansCounts(uid);
    }

    @Override
    public List<UserConcern> selectFansList(Integer uid) {

        UserConcernExample example = new UserConcernExample();
        Criteria criteria = example.createCriteria();
        criteria.andCuidEqualTo(uid);
        List<UserConcern> fansList = userConcernMapper.selectByExample(example);

        return fansList;
    }

    @Override
    public List<UserConcern> selectConcernList(Integer uid) {
        UserConcernExample example = new UserConcernExample();
        Criteria criteria = example.createCriteria();
        criteria.andUidEqualTo(uid);
        List<UserConcern> concernList = userConcernMapper.selectByExample(example);
        return concernList;
    }

    @Override
    public Integer insertConcern(Integer sessionId, Integer cuid) {
        UserConcern userConcern = new UserConcern();
        userConcern.setUid(sessionId);
        userConcern.setCuid(cuid);
        Integer result =  userConcernMapper.insertSelective(userConcern);

        //用户表被关注数增加
        userMapper.updateCnumByUID(cuid,1,0);//被关注数+1
        userMapper.updateCnumByUID(sessionId,0,1);//本人关注数+1
        return result;
    }

    @Override
    public List<UserConcern> selectAllConcernCUID(Integer sessionId) {
        return userConcernMapper.selectAllConcernCUID(sessionId);
    }

    @Override
    public Integer deleteConcern(Integer id,Integer cuid) {
        Integer result = userConcernMapper.delConcern(id,cuid);
        userMapper.updateCnumByUID(cuid,-1,0);//被关注数-1
        userMapper.updateCnumByUID(id,0,-1);//本人关注数-1
        return result;
  }
}

