package com.huojutech.service.Impl;

import com.huojutech.dao.UserMapper;
import com.huojutech.entity.User;
import com.huojutech.entity.UserExample;
import com.huojutech.entity.UserExample.Criteria;
import com.huojutech.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;

@Service
public class UserServiceImpl implements UserService{
    @Autowired
    private UserMapper userMapper;
    
    /*
     * (non-Javadoc)
     * @see com.huojutech.service.UserService#selectUserByUids(java.util.List)
     */
    @Override
    public List<User> selectUserByUids(List<Integer> uids) {
        UserExample example = new UserExample();
        Criteria c = example.createCriteria();
        c.andIdIn(uids);
        
        return userMapper.selectByExample(example);
    }

    /*
     * (non-Javadoc)
     * @see com.huojutech.service.UserService#selectUserById(java.lang.Integer)
     */
    @Override
    public User selectUserById(Integer uid) {
        return userMapper.selectByPrimaryKey(uid);
    }
    
    /*
     * (non-Javadoc)
     * @see com.huojutech.service.UserService#getUserByOpenId(java.lang.String)
     */
    @Override
    public User getUserByOpenId(String openId) {
        UserExample example = new UserExample();
        Criteria c = example.createCriteria();
        c.andWxOpenidEqualTo(openId);
        
        List<User> list = userMapper.selectByExample(example);
        if (CollectionUtils.isEmpty(list)) {
            return null;
        }
        return list.get(0);
    }

    /*
     * (non-Javadoc)
     * @see com.huojutech.service.UserService#updateAmountByUid(java.lang.Integer, java.lang.Double)
     */
    @Override
    public int updateAmountByUid(Integer uid, Double amount) {
        return userMapper.updateAmountByUid(uid, amount);
    }

    /*
     * (non-Javadoc)
     * @see com.huojutech.service.UserService#updateNumberById(java.lang.Integer, int, int, int)
     */
    @Override
    public int updateNumberById(Integer uid, int fnum, int vnum, int cnum,int voteNum) {
        return userMapper.updateNumberById(uid, fnum, vnum, cnum,voteNum);
    }

    @Override
    public Integer updateCnumByUID(User user) {
        return userMapper.updateByPrimaryKeySelective(user);
    }

    @Override
    public List<User> findUserByOpenId(String openId) {
        UserExample example = new UserExample();
        Criteria criteria = example.createCriteria();
        criteria.andWxOpenidEqualTo(openId);
        List<User> users = userMapper.selectByExample(example);
        return users;
    }

    @Override
    public Integer saveUser(User user) {
        return userMapper.insertSelective(user);
    }

    @Override
    public int updateUser(User user) {
        return userMapper.updateByPrimaryKeySelective(user);
    }

    @Override
    public List<User> selectRecommendUser() {
        return userMapper.selectRecommendUser();
    }

    @Override
    public List<User> selectRecommondUid() {
        return userMapper.selectRecommondUid();
    }

}
