package com.huojutech.service;

import com.huojutech.entity.StockForecastVote;

import java.util.List;

/**
 * 股票预测投票服务
 * @author zhoucong
 *
 */
public interface StockForecastVoteService{

    /**
     * 获取用户对某预测的投票记录
     * @param uid                   用户id
     * @param forecastId            预测id
     * @return
     */
    List<StockForecastVote> selectByUidAndForecastId(Integer uid, Integer forecastId);
    
    /**
     * 获取用户投票记录数
     * @param uid           
     * @param forecastId
     * @return
     */
    Integer countByUidAndForecastId(Integer uid, Integer forecastId);

    /**
     * 添加投票记录
     * @param vote
     * @return
     */
    int insert(StockForecastVote vote);
    
    /**
     * 统计用户投票数
     * @param uid
     * @return
     */
    Integer selectVoteCounts(Integer uid);
    
    /**
     * 添加用户投票记录
     * @param record
     * @return
     */
    int upsert(StockForecastVote record);

    /**
     * 通过用户和预测id获得投票信息
     * @param sessionId
     * @param id
     * @return
     */
    List<StockForecastVote> selectByUid(Integer sessionId, Integer id);

    /**
     * 通过预测id，查询投票结果集
     *
     * @param id
     * @return
     */
    List<StockForecastVote> selectByForecastId(Integer id);

    /**
     *更新投票的投票状态
     * @param stockForecastVote
     * @return
     */
    int updateVote(StockForecastVote stockForecastVote);

    /**
     * 通过用户id，查询投票集合
     * @param sessionId
     * @return
     */
    List<StockForecastVote> findVoteByUid(Integer sessionId);
}
