package com.huojutech.service;
import com.huojutech.entity.User;

import java.util.List;

/**
 * 用户service服务
 * @author zhoucong
 *
 */
public interface UserService {
    /**
     * 根据用户id批量获取用户列表集
     * @param uids
     * @return
     */
    List<User> selectUserByUids(List<Integer> uids);
    /**
     * 根据id获取用户信息
     * @param uid
     * @return
     */
    User selectUserById(Integer uid);
    
    User getUserByOpenId(String openId);
    
    /**
     * 修改用户火钻数
     * @param uid           用户id
     * @param amount        火钻数
     * @return
     */
    int updateAmountByUid(Integer uid, Double amount);
    
    /**
     * 加减指定用户预测数/投票数/被关注数
     * @param uid           用户id
     * @param fnum          预测数
     * @param vnum          投票数
     * @param cnum          被关注数
     * @return
     */
    int updateNumberById(Integer uid, int fnum, int vnum, int cnum,int voteNum);

    /**
     * 用户关注或取消关注更新被关注数
     * @param user
     * @return
     */
    Integer updateCnumByUID(User user);

    /**
     * 通过openId获取用户
     * @param openid
     * @return
     */
    List<User> findUserByOpenId(String openid);

    /**
     * 登录时保存用户信息到数据库
     * @param user
     * @return
     */
    Integer saveUser(User user);

    /**
     * 条件更新用户
     * @param user
     * @return
     */
    int updateUser(User user);

    /**
     * 查询推荐的预言家
     * @return
     */
    List<User> selectRecommendUser();

    /**
     * 查出被推荐的预言家列表
     * @return
     */
    List<User> selectRecommondUid();
}
