package com.huojutech.utils;

/**
 * 分页工具类
 * @author zhoucong
 *
 */
public class PageUtil {
	/* 默认分页大小 */
	private static Integer DEFAULT_PAGE_SIZE = 10;
	/* 默认 页码 */
	private static Integer DEFAULT_PAGE_INDEX = 1;
	
	private Integer size;
	private Integer offset;
	
	/**
	 * 构造函数
	 * @param size		分页大小
	 * @param page		页码，第一页为1
	 */
	public PageUtil(Integer size, Integer page){
		this.size = size != null && size > 0 ? size:DEFAULT_PAGE_SIZE;
		page = page != null && page > 0 ? page:DEFAULT_PAGE_INDEX;
		this.offset = (page - 1) * this.size;
	}

	public Integer getSize() {
		return size;
	}

	public void setSize(Integer size) {
		this.size = size;
	}

	public Integer getOffset() {
		return offset;
	}

	public void setOffset(Integer offset) {
		this.offset = offset;
	}
}
