package com.huojutech.vo;

import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 股票预测详情返回参数集
 * @author zhoucong
 *
 */
public class StockForecastDetailVO implements Serializable{
    private static final long serialVersionUID = -6919136280755023387L;

    private Integer id;
    @ApiModelProperty(value="是否是自己   0-不是  1-是")
    private Integer self;
    @ApiModelProperty(value="用户昵称")
    private String nickname;
    @ApiModelProperty(value="用户头像")
    private String avatar;
    @ApiModelProperty(value="用户历史准确率")
    private Double frateSuccess;
    @ApiModelProperty(value="目标价位")
    private Double target;
    @ApiModelProperty(value="预测周期 1-一周;2-一个月;3-两个月;4-3个月;5-六个月;6-一年")
    private Integer cycle;
    @ApiModelProperty(value="起始时间，时间戳/毫秒")
    private Long startDate;
    @ApiModelProperty(value="结束时间，时间戳/毫秒")
    private Long endDate;
    @ApiModelProperty(value="预测理由")
    private String reason;
    @ApiModelProperty(value="预期  0-看多;1-看空")
    private Integer expect;
    @ApiModelProperty(value="距离到期的天数")
    public Integer days;
    @ApiModelProperty(value="预测状态 0-进行中 1-预测成功  2-预测失败")
    private Integer status;
    @ApiModelProperty(value="是否收藏  0-未收藏   1-已收藏")
    private int collected;
    @ApiModelProperty(value="是否已投票  -1-未投票  0-赞成   1-反对")
    private int isAgree;
    @ApiModelProperty(value="参与人数")
    private int attendNumber;
    @ApiModelProperty(value="赞同人数")
    private int agreeNumber;
    @ApiModelProperty(value="赞同火钻数")
    private double agreeAmount;
    @ApiModelProperty(value="反对人数")
    private int againstNumber;
    @ApiModelProperty(value="反对火钻数")
    private double againstAmount;
    @ApiModelProperty(value="股票代码")
    private String stockCode;
    @ApiModelProperty(value="股票名称")
    private String stockName;
    @ApiModelProperty(value="涨幅")
    private Double changepercent;
    @ApiModelProperty(value="现价")
    private Double trade;
    @ApiModelProperty(value="开盘价")
    private Double open;
    @ApiModelProperty(value="市盈率")
    private Double per;
    @ApiModelProperty(value="总市值")
    private Double mktcap;
    @ApiModelProperty(value="流通市值")
    private Double nmc;
    @ApiModelProperty(value="状态：-1-删除 0-正常 1-投票成功 2-投票失败")
    private int voteStatus;
    @ApiModelProperty("投票成获得的火钻数")
    private BigDecimal voteSucCount;
    @ApiModelProperty(value="股票现价和昨天开盘价的差")
    private Double diff;

    public Double getDiff() {
        return diff;
    }

    public void setDiff(Double diff) {
        this.diff = diff;
    }

    public int getVoteStatus() {
        return voteStatus;
    }

    public void setVoteStatus(int voteStatus) {
        this.voteStatus = voteStatus;
    }

    public BigDecimal getVoteSucCount() {
        return voteSucCount;
    }

    public void setVoteSucCount(BigDecimal voteSucCount) {
        this.voteSucCount = voteSucCount;
    }

    public Integer getId() {
        return id;
    }
    public void setId(Integer id) {
        this.id = id;
    }
    public Integer getSelf() {
        return self;
    }
    public void setSelf(Integer self) {
        this.self = self;
    }
    public String getNickname() {
        return nickname;
    }
    public void setNickname(String nickname) {
        this.nickname = nickname;
    }
    public String getAvatar() {
        return avatar;
    }
    public void setAvatar(String avatar) {
        this.avatar = avatar;
    }
    public Double getTarget() {
        return target;
    }
    public void setTarget(Double target) {
        this.target = target;
    }
    public Integer getCycle() {
        return cycle;
    }
    public void setCycle(Integer cycle) {
        this.cycle = cycle;
    }
    public Long getStartDate() {
        return startDate;
    }
    public void setStartDate(Long startDate) {
        this.startDate = startDate;
    }
    public Long getEndDate() {
        return endDate;
    }
    public void setEndDate(Long endDate) {
        this.endDate = endDate;
    }
    public String getReason() {
        return reason;
    }
    public void setReason(String reason) {
        this.reason = reason;
    }
    public Integer getExpect() {
        return expect;
    }
    public void setExpect(Integer expect) {
        this.expect = expect;
    }
    public Double getFrateSuccess() {
        return frateSuccess;
    }
    public void setFrateSuccess(Double frateSuccess) {
        this.frateSuccess = frateSuccess;
    }
    public Integer getDays() {
        return days;
    }
    public void setDays(Integer days) {
        this.days = days;
    }
    public Integer getStatus() {
        return status;
    }
    public void setStatus(Integer status) {
        this.status = status;
    }
    public int getCollected() {
        return collected;
    }
    public void setCollected(int collected) {
        this.collected = collected;
    }
    public int getAttendNumber() {
        return attendNumber;
    }
    public void setAttendNumber(int attendNumber) {
        this.attendNumber = attendNumber;
    }
    public int getAgreeNumber() {
        return agreeNumber;
    }
    public void setAgreeNumber(int agreeNumber) {
        this.agreeNumber = agreeNumber;
    }
    public double getAgreeAmount() {
        return agreeAmount;
    }
    public void setAgreeAmount(double agreeAmount) {
        this.agreeAmount = agreeAmount;
    }
    public int getAgainstNumber() {
        return againstNumber;
    }
    public void setAgainstNumber(int againstNumber) {
        this.againstNumber = againstNumber;
    }
    public double getAgainstAmount() {
        return againstAmount;
    }
    public void setAgainstAmount(double againstAmount) {
        this.againstAmount = againstAmount;
    }
    public String getStockCode() {
        return stockCode;
    }
    public void setStockCode(String stockCode) {
        this.stockCode = stockCode;
    }
    public String getStockName() {
        return stockName;
    }
    public void setStockName(String stockName) {
        this.stockName = stockName;
    }
    public Double getChangepercent() {
        return changepercent;
    }
    public void setChangepercent(Double changepercent) {
        this.changepercent = changepercent;
    }
    public Double getTrade() {
        return trade;
    }
    public void setTrade(Double trade) {
        this.trade = trade;
    }
    public Double getOpen() {
        return open;
    }
    public void setOpen(Double open) {
        this.open = open;
    }
    public Double getPer() {
        return per;
    }
    public void setPer(Double per) {
        this.per = per;
    }
    public Double getMktcap() {
        return mktcap;
    }
    public void setMktcap(Double mktcap) {
        this.mktcap = mktcap;
    }
    public Double getNmc() {
        return nmc;
    }
    public void setNmc(Double nmc) {
        this.nmc = nmc;
    }
    public int getIsAgree() {
        return isAgree;
    }
    public void setIsAgree(int isAgree) {
        this.isAgree = isAgree;
    }
}
